{{
  Tester for DS1307 DIP-8
  Date: 21/11/2012
  H/W: Prop1ModRev1 on BB with u96-OLED
  
}}
CON

  '--- --- --- --- --- ---  
  'Declaring the CPU Freq & Crystal Clock
  '--- --- --- --- --- ---  
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  _ConClkFreq = ((_clkmode - xtal1) >> 6) * _xinfreq
  _Ms_001   = _ConClkFreq / 1_000


  'RTC
  _receiverPin    = 31
  _transmitterPin = 30

  _clockDataPin   = 29
  _clockClockPin  = 28

  
  '96
  _u96Tx        = 3
  _u96Rx        = 4
  _uBaudRate    = 115_200
  _u96WaitTime  = 10

  'Button
  _button       = %100
  


OBJ
  RTC:  "DS1307_RTCEngine.spin"
  u96:  "OLED-96-G1.spin"
  STR:  "ASCII0_STREngine.spin"
  


VAR

PUB Main
{{
  1. Init DS1307 & u96-OLED
  2. Read Current Date/Time & Display to u96
  3. When button pressed, Set New Date/Time & Display to u96
   
  
}}

  'H/W Init
  '--------
  DIRA[_button]~
  

  'Init
  '----

  'RTC
  ifnot( RTC.rtcEngineStart(_clockDataPin, _clockClockPin, -1) )
    reboot
  Pause(200)

  'u96
  u96.Start(_u96Rx, _u96Tx, _uBaudRate)
  Pause(200)


  'Disp Init
  u96Init


  'Display Time
  readAndDisplayTime


  'Wait for button pressed
  WAITPEQ(_button, _button, 0)


  'Setting Date & Time
  setNewDateTime


  'Display Time
  readAndDisplayTime
  

  repeat

  

PRI setNewDateTime
{{

}}

  RTC.writeTime(50, 59, 17, 7, 24, 11, 2012)
  Pause(50)
  

  return
  

PRI u96Init
{{

}}  
  u96.Choosecolor("g")    'Chooses color orange
  Pause(_u96WaitTime)
  u96.Setfont(0)''Sets font to 5x7
  Pause(_u96WaitTime)
  u96.Erase
  Pause(_u96WaitTime)

  return


PRI readAndDisplayTime | i
{{

}}  

  u96.Erase
  Pause(_u96WaitTime)
  u96.Placestring(2, 0, (string("DS1307 Test")), 11)
  Pause(_u96WaitTime)
  u96.Placestring(2, 1, (string("===========")), 11)
  Pause(_u96WaitTime)
  u96.Placestring(0, 2, (string("Date:")), 5)
  Pause(_u96WaitTime)
  u96.Placestring(0, 3, (string("Mth:")), 4)
  Pause(_u96WaitTime)
  u96.Placestring(0, 4, (string("Yr:")), 3)
  Pause(_u96WaitTime)
  u96.Placestring(0, 5, (string("Hr:")), 3)
  Pause(_u96WaitTime)
  u96.Placestring(0, 6, (string("Min:")), 4)
  Pause(_u96WaitTime)
  u96.Placestring(0, 7, (string("Sec:")), 4)
  Pause(_u96WaitTime)

  if(RTC.readTime)
    u96.Placestring(6, 2, STR.integerToDecimal(RTC.clockDate, 2), 4)
    Pause(_u96WaitTime)
    u96.Placestring(6, 3, STR.integerToDecimal(RTC.clockMonth, 2), 4)
    Pause(_u96WaitTime)
    u96.Placestring(6, 4, STR.integerToDecimal(RTC.clockYear, 4), 6)
    Pause(_u96WaitTime)
    u96.Placestring(6, 5, STR.integerToDecimal(RTC.clockHour, 2), 4)
    Pause(_u96WaitTime)
    u96.Placestring(6, 6, STR.integerToDecimal(RTC.clockMinute, 2), 4)
    Pause(_u96WaitTime)
    u96.Placestring(6, 7, STR.integerToDecimal(RTC.clockSecond, 2), 4)
    Pause(_u96WaitTime)
  else
    repeat i from 2 to 7
      u96.Placestring(6, i, (String("Err")), 3)    
      Pause(_u96WaitTime)

  return    




PRI Pause(ms) | t
{{Delay program ms milliseconds}}

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += _MS_001)